///home/berryj/link/bin/genMethods "-g" "-t" "int" "-h" "SubSet" "-I" "LINK/basic/SubSet.h" "-y" "display_subset_int" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SubSet.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_subset_int(SCM, SCM, int);

typedef int _int;
typedef SubSet<int > _SubSet_int_;
static SubSet<int > s__SubSet_int_;

#define _SubSet_int_DATA(x) ((SubSet<int >*) (EXTDATA(x)))
#define _SubSet_int_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SubSet<int > >::type))
#define _SubSet_int_ISNT_DATA(x) (!_SubSet_int_IS_DATA(x))

#define _SubSet_int_CXX_DATA(x) (*(SubSet<int >*) (EXTDATA(VAL(x))))
#define _SubSet_int_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SubSet<int > >::type))
#define _SubSet_int_CXX_ISNT_DATA(x) (!_SubSet_int_CXX_IS_DATA(x))


#include <strstream.h>

// define your new methods above 
// and register them using STk_add_new_cpp_primitive() below
void display_subset_int(SCM c, SCM port, int mode)
{
        ostrstream oss;
        if (_SubSet_int_DATA(c))
        	oss << *_SubSet_int_DATA(c);
        oss << ends;
        char *buffer = oss.str();
        Puts(buffer, (port));
        delete buffer;
}

void genExtra_SubSet_int_Methods() {}
